Skip to main content

## PerfCommand

# Enum PerfCommand

Source

    enum PerfCommand {
        Eprintln {
            opts: SharedOpts,
        },
        Samply {
            opts: SharedOpts,
        },
        Cachegrind {
            opts: SharedOpts,
        },
        Benchmark {
            id: String,
            opts: SharedOpts,
        },
        Compare {
            base: String,
            modified: String,
        },
    }

## Variants§

§

### Eprintln

Run `profile_local eprintln`. This executes the compiler on the given benchmarks and stores its stderr output.

#### Fields

§`opts: SharedOpts`
§

### Samply

Run `profile_local samply` This executes the compiler on the given benchmarks and profiles it with `samply`. You need to install `samply`, e.g. using `cargo install samply`.

#### Fields

§`opts: SharedOpts`
§

### Cachegrind

Run `profile_local cachegrind`. This executes the compiler on the given benchmarks under `Cachegrind`.

#### Fields

§`opts: SharedOpts`
§

### Benchmark

Run compile benchmarks with a locally built compiler.

#### Fields

§`id: String`

Identifier to associate benchmark results with

§`opts: SharedOpts`
§

### Compare

Compare the results of two previously executed benchmark runs.

#### Fields

§`base: String`

The name of the base artifact to be compared.

§`modified: String`

The name of the modified artifact to be compared.

## Implementations§

Source§

### impl PerfCommand

Source

#### fn shared_opts(&self) -> Option<&SharedOpts>

## Trait Implementations§

Source§

### impl Clone for PerfCommand

Source§

#### fn clone(&self) -> PerfCommand

Returns a duplicate of the value. Read more
1.0.0 (const: unstable) · Source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
Source§

### impl CommandFactory for PerfCommand

Source§

#### fn command<'b>() -> Command

Build a [`Command`] that can instantiate `Self`. Read more
Source§

#### fn command_for_update<'b>() -> Command

Build a [`Command`] that can update `self`. Read more
Source§

### impl Debug for PerfCommand

Source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
Source§

### impl FromArgMatches for PerfCommand

Source§

#### fn from_arg_matches(__clap_arg_matches: &ArgMatches) -> Result<Self, Error>

Instantiate `Self` from [`ArgMatches`], parsing the arguments as needed. Read more
Source§

#### fn from_arg_matches_mut( __clap_arg_matches: &mut ArgMatches, ) -> Result<Self, Error>

Instantiate `Self` from [`ArgMatches`], parsing the arguments as needed. Read more
Source§

#### fn update_from_arg_matches( &mut self, __clap_arg_matches: &ArgMatches, ) -> Result<(), Error>

Assign values from `ArgMatches` to `self`.
Source§

#### fn update_from_arg_matches_mut<'b>( &mut self, __clap_arg_matches: &mut ArgMatches, ) -> Result<(), Error>

Assign values from `ArgMatches` to `self`.
Source§

### impl Parser for PerfCommand

§

#### fn parse() -> Self

Parse from `std::env::args_os()`, [exit][Error::exit] on error.
§

#### fn try_parse() -> Result<Self, Error>

Parse from `std::env::args_os()`, return Err on error.
§

#### fn parse_from<I, T>(itr: I) -> Self
where I: IntoIterator<Item = T>, T: Into<OsString> + Clone,

Parse from iterator, [exit][Error::exit] on error.
§

#### fn try_parse_from<I, T>(itr: I) -> Result<Self, Error>
where I: IntoIterator<Item = T>, T: Into<OsString> + Clone,

Parse from iterator, return Err on error.
§

#### fn update_from<I, T>(&mut self, itr: I)
where I: IntoIterator<Item = T>, T: Into<OsString> + Clone,

Update from iterator, [exit][Error::exit] on error. Read more
§

#### fn try_update_from<I, T>(&mut self, itr: I) -> Result<(), Error>
where I: IntoIterator<Item = T>, T: Into<OsString> + Clone,

Update from iterator, return Err on error.
Source§

### impl Subcommand for PerfCommand

Source§

#### fn augment_subcommands<'b>(__clap_app: Command) -> Command

Append to [`Command`] so it can instantiate `Self` via [`FromArgMatches::from_arg_matches_mut`] Read more
Source§

#### fn augment_subcommands_for_update<'b>(__clap_app: Command) -> Command

Append to [`Command`] so it can instantiate `self` via [`FromArgMatches::update_from_arg_matches_mut`] Read more
Source§

#### fn has_subcommand(__clap_name: &str) -> bool

Test whether `Self` can parse a specific subcommand

## Auto Trait Implementations§

§

### impl Freeze for PerfCommand

§

### impl RefUnwindSafe for PerfCommand

§

### impl Send for PerfCommand

§

### impl Sync for PerfCommand

§

### impl Unpin for PerfCommand

§

### impl UnsafeUnpin for PerfCommand

§

### impl UnwindSafe for PerfCommand

## Blanket Implementations§

Source§

### impl<T> Any for T
where T: 'static + ?Sized,

Source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
Source§

### impl<T> Borrow<T> for T
where T: ?Sized,

Source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
Source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

Source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
Source§

### impl<T> CloneToUninit for T
where T: Clone,

Source§

#### unsafe fn clone_to_uninit(&self, dest: *mut u8)

🔬This is a nightly-only experimental API. (`clone_to_uninit`)
Performs copy-assignment from `self` to `dest`. Read more
Source§

### impl<T> From<T> for T

Source§

#### fn from(t: T) -> T

Returns the argument unchanged.

Source§

### impl<T, U> Into<U> for T
where U: From<T>,

Source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

§

### impl<T> Pointable for T

§

#### const ALIGN: usize

The alignment of pointer.
§

#### type Init = T

The type for initializers.
§

#### unsafe fn init(init: <T as Pointable>::Init) -> usize

Initializes a with the given initializer. Read more
§

#### unsafe fn deref<'a>(ptr: usize) -> &'a T

Dereferences the given pointer. Read more
§

#### unsafe fn deref_mut<'a>(ptr: usize) -> &'a mut T

Mutably dereferences the given pointer. Read more
§

#### unsafe fn drop(ptr: usize)

Drops the object pointed to by the given pointer. Read more
Source§

### impl<T> Same for T

Source§

#### type Output = T

Should always be `Self`
Source§

### impl<T> ToOwned for T
where T: Clone,

Source§

#### type Owned = T

The resulting type after obtaining ownership.
Source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
Source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
Source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

Source§

#### type Error = Infallible

The type returned in the event of a conversion error.
Source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
Source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

Source§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
Source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 120 bytes

Size for each variant:

- `Eprintln`: 104 bytes
- `Samply`: 104 bytes
- `Cachegrind`: 104 bytes
- `Benchmark`: 120 bytes
- `Compare`: 56 bytes